/*  *************************************************************************

	Shadow Door - a Neverwinter Nights NPC control interface
	Copyright 2003 by Robert Zubek and Phillip Saltzman, Northwestern University
    email: rob@cs.northwestern.edu, p-saltzman@northwestern.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

************************************************************************** */


//
//
// generic definitions shared among header files



#if _MSC_VER > 1000
#pragma once
#endif 

#ifndef SD_DEFINITIONS_H
#define SD_DEFINITIONS_H

#include "definitions.h"


//
//
// constants

// the shadow door socket port
#define SD_PORT 1890

// some literals
#define LF 0x0a
#define CR 0x0d


// forward reference 
class ShadowDoor;
typedef char* (ShadowDoor::*ShadowDoorFnPtr) (char *);

//
//
// STL containers 

using namespace std;

// string comparison for STL containers
struct strLess {
   bool operator()(const char *left, const char *right) const {
	   return strcmp (left, right) < 0;
   }
};

// useful typedefs
typedef queue <char *> Msg;
typedef queue <Msg *> MsgQueue;
typedef hash_map <char *, ShadowDoorFnPtr, hash_compare <char *, strLess> > HandlerMap; 




#endif // SD_DEFINITIONS_H