/*  *************************************************************************

	Shadow Door - a Neverwinter Nights NPC control interface
	Copyright 2003 by Robert Zubek and Phillip Saltzman, Northwestern University
    email: rob@cs.northwestern.edu, p-saltzman@northwestern.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

************************************************************************** */


//
//
// this file includes all globally-accessible elements, such as
// extern'ed globals, non-member functions, and other such

#include "stdafx.h"


// global function that creates and returns a pointer to the
// singleton instance of shadow door

SHADOWDOOR_API CNWNXBase* GetClassObject ()
{
	return (CNWNXBase *) ShadowDoor::GetInstance ();
}

// a global function that wraps the shadow door listener function
// in a (DWORD WINAPI *)() signature

DWORD WINAPI RunListenerWrapper (LPVOID lpParam) 
{ 
	ShadowDoor *sd = ShadowDoor::GetInstance ();
	sd->RunListener ();
	return 0; 
} 


// Initialize the server socket for listening for connections

SOCKET initServerSock() 
{
	ShadowDoor *sd = ShadowDoor::GetInstance ();
	SOCKET servSock;
	sockaddr_in servAddr;
	int state = 0;

	//Listens for any incomming connection on the default port
	servSock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	memset(&servAddr, 0, sizeof(servAddr));
	servAddr.sin_family=AF_INET;
	servAddr.sin_addr.S_un.S_addr = htonl(INADDR_ANY);
	servAddr.sin_port = htons(SD_PORT);

	state = bind(servSock, (sockaddr*)&servAddr, (sizeof(servAddr)));
	if (state < 0)
		sd->Log ("bind returned error %d\n", WSAGetLastError());
	state = listen(servSock, 2);
	if (state < 0)
		sd->Log ("listen returned error %d\n", WSAGetLastError());

	return servSock;
}


//
//
// dll access

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}
